var shouldHoverLink;
var hoverLinkObj;
var hoverLinkTimeout;

function preload(images){
    // Create object
    var imageObj = new Image();
	
    // Preload Images
    for(var i = 0; i <= images.length; i++) 
    {
        imageObj.src = images[i];
    }
}

function keyCodeAction(){
    if(event.keyCode == 37){ // Left Arrow
        prevShelfStory(event.altKey);
    }

    if(event.keyCode == 39){ // Right Arrow
        nextShelfStory(event.altKey);
    }

    if(event.keyCode == 27){ // Esc Key
        document.location.href = "presses://closeStory/";
    }
}	
        
function setArticle(article){
    document.getElementById("article").innerHTML = article;
    document.getElementById("photo").innerHTML = "";
    document.getElementById("photoContainer").style.display = "none";
    enhanceLinks();
}

function setArticleTitle(title){
    document.getElementById("article-title").innerHTML = title;
}

function setArticleHref(href){
    if(href == ""){
        document.getElementById("article-title").removeAttribute("href");				
    }else{
        document.getElementById("article-title").href = href;
    }
}

function setDate(date){
    document.getElementById("header-date").innerHTML = date;
}

function setStatus(status){
    document.getElementById("header-error").style.display = "none";
    
    if(status == "1"){
        document.getElementById("header-error").style.display = "block";
        document.getElementById("header-error").style.background = "url(images/warning.png) center center no-repeat";
    }
    
    if(status == "2"){
        document.getElementById("header-error").style.display = "block";
        document.getElementById("header-error").style.background = "url(images/loading.gif) center center no-repeat";
    }
}

function setSource(source, icon){
    document.getElementById("header-source").innerHTML = source;
    document.getElementById("header-source").style.paddingLeft = "0px";
    document.getElementById("header-source").style.backgroundImage = "none";
}

function enhanceLinks(){
    var aLinks = document.getElementById("article").getElementsByTagName("a");
    for(var i = 0; i < aLinks.length; i++){
        var aObj = aLinks[i];
        
		if(aObj.innerHTML.indexOf("<img") >= 0)
			continue;
		
		aObj.onmouseover = function(){beginHover(this);};
        aObj.onmouseout = function(){endHover(this);};
    }
}

function beginHover(obj){
    shouldHoverLink = true;
    hoverLinkObj = obj;
    hoverLinkTimeout = setTimeout("hoverLink();", 500);
}

function endHover(obj){
	clearTimeout(hoverLinkTimeout);
    shouldHoverLink = false;
    document.getElementById("hoverLink").style.display = "none";			
}

function hoverLink(){
    if(shouldHoverLink == false)
        return;
	
	var obj = hoverLinkObj;
	
    var xPos = findPosX(obj);
    var yPos = findPosY(obj);
    var width = obj.offsetWidth;
	
    var linkObj = document.getElementById("hoverLink");
    linkObj.style.opacity = 0;
    linkObj.style.display = "block";

	document.getElementById("hoverLink-blip").style.display = "block";
		
    var innerLinkObj = document.getElementById("hoverLink-link");
    innerLinkObj.innerHTML = obj.href;
    
    var blipOffset = 5;
    var productX = xPos + (width / 2) - (innerLinkObj.offsetWidth / 2);
    if(productX < 10){
        productX = 10;
        blipOffset = 15 + (innerLinkObj.offsetWidth / 2); // 0!
        blipOffset = blipOffset - xPos - (width / 2);
    }

    if((productX + innerLinkObj.offsetWidth) > (document.body.offsetWidth)){
        productX = document.body.offsetWidth + 30 - innerLinkObj.offsetWidth;
        blipOffset = 35 + (-1)*(innerLinkObj.offsetWidth / 2); // max!
        blipOffset = blipOffset + (document.body.offsetWidth - xPos - width) + (width / 2);
    }
	
	if(obj.offsetHeight > 20){
		blipOffset = 0;
		document.getElementById("hoverLink-blip").style.display = "none";
	}
	
    linkObj.style.left = productX + "px";
    linkObj.style.top = yPos - 24 + "px";	
    
    document.getElementById("hoverLink-blip").style.marginLeft = -1 * blipOffset + "px";
	opacity("hoverLink", 0, 100, 150);
}

function opacity(id, opacStart, opacEnd, millisec) { 
    var speed = Math.round(millisec / 100); 
    var timer = 0; 

    if(opacStart > opacEnd) { 
        for(i = opacStart; i >= opacEnd; i--) { 
            setTimeout("changeOpac(" + i + ",'" + id + "')",(timer * speed)); 
            timer++; 
        } 
    } else if(opacStart < opacEnd) { 
        for(i = opacStart; i <= opacEnd; i++) 
            { 
            setTimeout("changeOpac(" + i + ",'" + id + "')",(timer * speed)); 
            timer++; 
        } 
    } 
} 

function changeOpac(opacity, id) { 
    var object = document.getElementById(id).style; 
    object.opacity = (opacity / 100); 
}

  function findPosX(obj)
  {
    var curleft = 0;
    if(obj.offsetParent)
        while(1) 
        {
          curleft += obj.offsetLeft;
          if(!obj.offsetParent)
            break;
          obj = obj.offsetParent;
        }
    else if(obj.x)
        curleft += obj.x;
    return curleft;
  }

  function findPosY(obj)
  {
    var curtop = 0;
    if(obj.offsetParent)
        while(1)
        {
          curtop += obj.offsetTop;
          if(!obj.offsetParent)
            break;
          obj = obj.offsetParent;
        }
    else if(obj.y)
        curtop += obj.y;
    return curtop;
  }

function setPhoto(photo, reflection, width){	
    document.getElementById("photoContainer").style.display = "block";
    document.getElementById("photo").innerHTML = "<img width=\"100%\" id=\"image\" ondragstart=\"return false;\" src=\"" + photo + "\"></img>";
	document.getElementById("reflection").style.backgroundImage = "url(" + reflection + ")";
    document.getElementById("photoBoxInner").style.width = width;
    
    document.getElementById("imgbrd").x = findPosX(document.getElementById("photo"));
    document.getElementById("imgbrd").y = findPosY(document.getElementById("photo"));
    document.getElementById("imgbrd").style.width = document.getElementById("image").offsetWidth - 2 + "px";
    document.getElementById("imgbrd").style.height = document.getElementById("image").clientHeight - 2 + "px";

    if(width == "100%")
        document.getElementById("control-preview").style.display = "block";
    else
        document.getElementById("control-preview").style.display = "none";

}

function setShelf(displayStyle, arrowType){
    document.getElementById("shelf-button").className = displayStyle;
    if(displayStyle == "off"){
        document.getElementById("arrow-left").style.opacity = "0";
        document.getElementById("arrow-right").style.opacity = "0";
    }else{
        var leftOpacity = "1";
        var rightOpacity = "1";
        
        if(arrowType == "2")
            rightOpacity = "0";
        if(arrowType == "0")
            leftOpacity = "0";
        if(arrowType == "3"){
            rightOpacity = "0";
            leftOpacity = "0";
        }
        
        document.getElementById("arrow-left").style.opacity = leftOpacity;
        document.getElementById("arrow-right").style.opacity = rightOpacity;
    }
}

function toggleShelf(){
    var button = document.getElementById("shelf-button");
    if(button.className == "on"){
        document.location.href = "presses://shelfOff/";
    }else{
        document.location.href = "presses://shelfOn/";
    }
}
            
function nextShelfStory(deleteLast){
    if(document.getElementById("arrow-right").style.opacity == "1")
        document.location.href = "presses://nextShelfStory/" + deleteLast;
}

function prevShelfStory(deleteLast){
    if(document.getElementById("arrow-left").style.opacity == "1")
        document.location.href = "presses://prevShelfStory/" + deleteLast;
}

function enlargePhoto(){
    document.location.href = "presses://enlargePhoto/";
}

function removeEnclosures(){
    document.getElementById("enclosures").innerHTML = "";
}

function addEnclosure(title, URL, size){
    var newEnclosure = "<a class=\"enclink\" href=\"" + URL + "\"><div class=\"enclosure\"><div class=\"enclosure-title\">" + title + " (" + size + ")</div></div></a>";
    document.getElementById("enclosures").innerHTML = document.getElementById("enclosures").innerHTML + newEnclosure;
}
